Bug 15186 - Is a mechanism to auto-generate regions necessary in order to support reusable style sheets?
Summary: Is a mechanism to auto-generate regions necessary in order to support reusabl...
Alias: None
Product: CSS
Classification: Unclassified
Component: Regions (show other bugs)
Version: unspecified
Hardware: PC All
: P2 normal
Target Milestone: ---
Assignee: Vincent Hardy
QA Contact:
URL: http://lists.w3.org/Archives/Public/w...
Whiteboard: editorial
Depends on:
Reported: 2011-12-14 22:39 UTC by Vincent Hardy
Modified: 2012-11-05 20:32 UTC (History)
4 users (show)

See Also:


Note You need to log in before you can comment on or make changes to this bug.
Description Vincent Hardy 2011-12-14 22:39:40 UTC

It seems that the current regions model create a fixed set of regions.
If the content poured into the regions take up more space than the
fixed set of regions can hold, no additional regions will be generated
automatically. This is a side-effect of using structural elements as

This solution may work for one-off designs where the authoring tool
knows everything about the content, which font to use, which font size
that's used etc. I.e., it's not a good solution for a web with many
types of display devices and users with varying font-size preferences.

It has been suggested that, in order to generate more regions, a
script should be invoked. I don't think it is acceptable to rely on
scripting for a fairly basic function to work.

Are there other alternatives? I believe that the multicol module [3]
offers an alternative. Columns are generated as needed, and content
flows from one to the next -- just like for regions. If we added a way
toBin select and style individual columns, we could size and position
them. They could escape the rigid framework that multicol currently
provides, and fly like angels. Angelic columns. 

For example, to turn the first columnn of an article into something
special, we could write:

  article { columns: 14em; }
  article::column(1) { 
     position: absolute; 
     font-size: 1.2em;
     visibility: collapse; /* makes space available others to use */

For now, this is just a strawman proposal. But it shows that it's
possible to have stylable regions that naturally combine

An issue has been added to the latest WD which somewhat describes the
concern [4]:

  ISSUE: should we allow the following: a magazine articles with
  regions galore on the first page, and then it switches to simple
  multi-column layout from page 2 and onwards

The proposed solution to the issue is:

  May be an interesting feature, but should move to next revision of
  CSS regions for simplicity.

I don't think we can delay auto-generation until the next revision.
It's a fundamental feature that needs to be described now. If it
cannot easily be described, the model may be flawed.

I'd like to reformulate the issue (or add this text in a new issue):

  ISSUE: A mechanism to auto-generate regions is necessary in order to
  support reusable style sheets.
Comment 1 Rossen Atanassov 2012-02-07 09:13:40 UTC
Paris F2F - this should be addressed by the CSS Page Template module.
Comment 3 Alan Stearns 2012-11-05 20:32:21 UTC
CSSWG resolved to close: